/* getasm.c                           written by Kenji Kise, 2001
 * A part of SimpleScalar Simulator.          Developing on Linux
 ****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "define.h"

void getopcode(int op, char *b){
  switch(op){
  case __J:          sprintf(b,"j"); break;
  case __JAL:        sprintf(b,"jal"); break;
  case __JR:         sprintf(b,"jr"); break;
  case __JALR:       sprintf(b,"jalr"); break;
  case __BEQ:        sprintf(b,"beq"); break;
  case __BNE:        sprintf(b,"bne"); break;
  case __BLEZ:       sprintf(b,"blez"); break;
  case __BGTZ:       sprintf(b,"bgtz"); break;
  case __BLTZ:       sprintf(b,"bltz"); break;
  case __BGEZ:       sprintf(b,"bgez"); break;
  case __BC1F:       sprintf(b,"bc1f"); break;
  case __BC1T:       sprintf(b,"bc1t"); break;

  case __LB:         sprintf(b,"lb"); break;
  case __LBU:        sprintf(b,"lbu"); break;
  case __LH:         sprintf(b,"lh"); break;
  case __LHU:        sprintf(b,"lhu"); break;
  case __LW:         sprintf(b,"lw"); break;
  case __DLW:        sprintf(b,"dlw"); break;
  case __L_S:        sprintf(b,"l.s."); break;
  case __L_D:        sprintf(b,"l.d."); break;
  case __LWL:        sprintf(b,"lwl"); break;
  case __LWR:        sprintf(b,"lwr"); break;
  case __SB:         sprintf(b,"sb"); break;
  case __SH:         sprintf(b,"sh"); break;
  case __SW:         sprintf(b,"sw"); break;
  case __S_S:        sprintf(b,"s.s."); break;
  case __DSW:        sprintf(b,"dsw"); break;
  case __S_D:        sprintf(b,"s.d."); break;
  case __DSZ:        sprintf(b,"dsz"); break;
  case __SWL:        sprintf(b,"swl"); break;
  case __SWR:        sprintf(b,"swr"); break;

  case __ADD:        sprintf(b,"add"); break;
  case __ADDI:       sprintf(b,"addi"); break;
  case __ADDU:       sprintf(b,"addu"); break;
  case __ADDIU:	     sprintf(b,"addiu"); break;
  case __SUB:        sprintf(b,"sub"); break;
  case __SUBU:       sprintf(b,"subu"); break;
  case __MULT:       sprintf(b,"mult"); break;
  case __MULTU:      sprintf(b,"multu"); break;
  case __DIV:        sprintf(b,"div"); break;
  case __DIVU:       sprintf(b,"divu"); break;
  case __MFHI:       sprintf(b,"mfhi"); break;
  case __MTHI:       sprintf(b,"mthi"); break;
  case __MFLO:       sprintf(b,"mflo"); break;
  case __MTLO:       sprintf(b,"mtlo"); break;
  case __AND:        sprintf(b,"and"); break;
  case __ANDI:       sprintf(b,"andi"); break;
  case __OR:         sprintf(b,"or"); break;
  case __ORI:        sprintf(b,"ori"); break;
  case __XOR:        sprintf(b,"xor"); break;
  case __XORI:       sprintf(b,"xori"); break;
  case __NOR:        sprintf(b,"nor"); break;
  case __SLL:        sprintf(b,"sll"); break;
  case __SLLV:       sprintf(b,"sllv"); break;
  case __SRL:        sprintf(b,"srl"); break;
  case __SRLV:       sprintf(b,"srlv"); break;
  case __SRA:        sprintf(b,"sra"); break;
  case __SRAV:       sprintf(b,"srav"); break;
  case __SLT:        sprintf(b,"slt"); break;
  case __SLTI:       sprintf(b,"slti"); break;
  case __SLTU:       sprintf(b,"sltu"); break;
  case __SLTIU:      sprintf(b,"sltiu"); break;

  case __FADD_S:     sprintf(b,"fadd.s"); break;
  case __FADD_D:     sprintf(b,"fadd.d"); break;
  case __FSUB_S:     sprintf(b,"fsub.s"); break;
  case __FSUB_D:     sprintf(b,"fsub.d"); break;
  case __FMUL_S:     sprintf(b,"fmul.s"); break;
  case __FMUL_D:     sprintf(b,"fmul.d"); break;
  case __FDIV_S:     sprintf(b,"fdiv.s"); break;
  case __FDIV_D:     sprintf(b,"fdiv.d"); break;
  case __FABS_S:     sprintf(b,"fabs.s"); break;
  case __FABS_D:     sprintf(b,"fabs.d"); break;
  case __FMOV_S:     sprintf(b,"fmov.s"); break;
  case __FMOV_D:     sprintf(b,"fmov.d"); break;
  case __FNEG_S:     sprintf(b,"fneg.s"); break;
  case __FNEG_D:     sprintf(b,"fneg.d"); break;
  case __CVT_S_D:    sprintf(b,"cvt.s.d"); break;
  case __CVT_S_W:    sprintf(b,"cvt.s.w"); break;
  case __CVT_D_S:    sprintf(b,"cvt.d.s"); break;
  case __CVT_D_W:    sprintf(b,"cvt.d.w"); break;
  case __CVT_W_S:    sprintf(b,"cvt.w.s"); break;
  case __CVT_W_D:    sprintf(b,"cvt.w.d"); break;
  case __C_EQ_S:     sprintf(b,"c.eq.s"); break;
  case __C_EQ_D:     sprintf(b,"c.eq.d"); break;
  case __C_LT_S:     sprintf(b,"c.lt.s"); break;
  case __C_LT_D:     sprintf(b,"c.lt.d"); break;
  case __C_LE_S:     sprintf(b,"c.le.s"); break;
  case __C_LE_D:     sprintf(b,"c.le.d"); break;
  case __FSQRT_S:    sprintf(b,"fsqrt.s"); break;
  case __FSQRT_D:    sprintf(b,"fsqrt.d"); break;

  case __NOP:       sprintf(b,"nop"); break;
  case __SYSCALL:   sprintf(b,"syscall"); break;
  case __BREAK:     sprintf(b,"break"); break;
  case __LUI:       sprintf(b,"lui"); break;
  case __MFC1:      sprintf(b,"mfc1"); break;
  case __CFC1:      sprintf(b,"cfc1"); break;
  case __MTC1:      sprintf(b,"mtc1"); break;
  case __CTC1:      sprintf(b,"ctc1"); break;
  case __DMFC1:     sprintf(b,"dmfc1"); break;
  case __DMTC1:     sprintf(b,"dmtc1"); break;
  case __LB_RR:     sprintf(b,"lb.rr"); break;
  case __LBU_RR:    sprintf(b,"lbu.rr"); break;
  case __LHU_RR:    sprintf(b,"lhu.rr"); break;
  case __LW_RR:     sprintf(b,"l.w.rr"); break;
  case __L_S_RR:    sprintf(b,"l.s.rr"); break;
  case __SB_RR:     sprintf(b,"sb.rr"); break;
  case __SH_RR:     sprintf(b,"sh.rr"); break;
  case __SW_RR:     sprintf(b,"sw.rr"); break;
  case __S_S_RR:    sprintf(b,"s.s.rr"); break;
  case __L_S_RR_R2: sprintf(b,"l.s.rr.r2"); break;
  case __S_S_RR_R2: sprintf(b,"s.s.rr_r2"); break;
  case __LW_RR_R2:  sprintf(b,"lw.rr.r2"); break;
  case __SW_RR_R2:  sprintf(b,"sw.rr.r2"); break;
  case __DLW_RR:    sprintf(b,"dlw.rr"); break;
  case __L_D_RR:    sprintf(b,"l.d.rr"); break;
  case __DSW_RR:    sprintf(b,"dsw.rr"); break;
  case __DSZ_RR:    sprintf(b,"dsz.rr"); break;
  case __S_D_RR:    sprintf(b,"s.d.rr"); break;
  case __LH_RR :    sprintf(b,"lh.rr"); break;
  default:          sprintf(b,"N/A"); break;
  }
}


void getasm(struct architecture_state *as, char *buf){
  char b[128];
  int opcode = as->ir.op & 0xff;

  getopcode(opcode, buf);
  switch(opcode){
  case __J:   sprintf(b,"0x%08x",(Cpc&0xf0000000)|(Target<<2));break;
  case __JAL: sprintf(b,"0x%08x",(Cpc&0xf0000000)|(Target<<2));break;
  case __JR:  sprintf(b,"0x%08x", Rs);break;    
  case __JALR:sprintf(b,"0x%08x", Rs);break;
  case __BEQ: sprintf(b,"$%d, $%d, 0x%08x",Rt_i,Rs_i,Imm);break;
  case __BNE: sprintf(b,"$%d, $%d, 0x%08x",Rt_i,Rs_i,Imm);break;
  case __BLEZ:sprintf(b,"$%d, $%d, 0x%08x",Rt_i,Rs_i,Imm);break;
  case __BGTZ:sprintf(b,"$%d, $%d, 0x%08x",Rt_i,Rs_i,Imm);break;
  case __BLTZ:sprintf(b,"$%d, $%d, 0x%08x",Rt_i,Rs_i,Imm);break;
  case __BGEZ:sprintf(b,"$%d, $%d, 0x%08x",Rt_i,Rs_i,Imm);break;
  case __BC1F:sprintf(b,"0x%x", Imm);break;
  case __BC1T:sprintf(b,"0x%x", Imm);break;

  case __LB: 
  case __LBU:
  case __LH: 
  case __LHU:
  case __LW: 
  case __DLW:
  case __LWL:
  case __LWR:
  case __SB: 
  case __SH: 
  case __SW: 
  case __DSZ:
  case __SWL:
  case __SWR:sprintf(b,"$%d, %d($%d)", Rt_i, Imm, Rs_i);break;

  case __L_S:
  case __L_D:
  case __S_S:
  case __DSW:
  case __S_D:sprintf(b,"$f%d, %d($%d)", Rt_i, Imm, Rs_i);break;

  case __ADDI: 
  case __ADDIU:
  case __ANDI: 
  case __ORI:  
  case __XORI: 
  case __SLTI: 
  case __SLTIU:sprintf(b,"$%d, $%d, 0x%x", Rt_i,Rs_i,Imm);break;

  case __ADD:  
  case __ADDU: 
  case __SUB:  
  case __SUBU: 
  case __AND:  
  case __OR:   
  case __XOR:  
  case __NOR:  
  case __SLLV: 
  case __SRLV: 
  case __SRAV: 
  case __SLT:  
  case __SLTU: sprintf(b,"$%d, $%d, $%d", Rd_i,Rs_i,Rt_i);break;

  case __MULT: 
  case __MULTU:
  case __DIV:  
  case __DIVU: 
  case __MFHI: 
  case __MTHI: 
  case __MFLO: 
  case __MTLO: sprintf(b, " "); break;

  case __SLL: 
  case __SRL: 
  case __SRA:  sprintf(b,"$%d, $%d, %d", Rd_i, Rt_i, Shamt);break;

  case __FADD_S: 
  case __FADD_D: 
  case __FSUB_S: 
  case __FSUB_D: 
  case __FMUL_S: 
  case __FMUL_D: 
  case __FDIV_S: 
  case __FDIV_D: 
  case __FABS_S: sprintf(b,"$f%d, $f%d, $f%d", Rd_i,Rs_i,Rt_i);break;

  case __FABS_D   : 
  case __FMOV_S   : 
  case __FMOV_D   : 
  case __FNEG_S   : 
  case __FNEG_D   : 
  case __CVT_S_D  :
  case __CVT_S_W  :
  case __CVT_D_S  :
  case __CVT_D_W  :
  case __CVT_W_S  :
  case __CVT_W_D  :
  case __FSQRT_S  :
  case __FSQRT_D  :sprintf(b,"$f%d, $f%d", Rd_i, Rs_i);break;
  case __C_EQ_S   : 
  case __C_EQ_D   : 
  case __C_LT_S   : 
  case __C_LT_D   : 
  case __C_LE_S   : 
  case __C_LE_D   :sprintf(b,"$f%d, $f%d", Rs_i, Rt_i);break;


  case __LUI      :sprintf(b,"$%d, 0x%08x", Rt_i, UImm<<16);break;
  case __MFC1     :sprintf(b,"$%d, $f%d", Rt_i, Rs_i);break;
  case __MTC1     :sprintf(b,"$f%d, $%d", Rs_i, Rt_i);break;
  case __DMFC1    :sprintf(b,"$%d, $f%d", Rt_i, Rs_i);break;

  case __DMTC1    :
  case __LB_RR    :
  case __LBU_RR   :
  case __LHU_RR   :
  case __LW_RR    :
  case __L_S_RR   :
  case __SB_RR    :
  case __SH_RR    :
  case __SW_RR    :
  case __S_S_RR   :
  case __L_S_RR_R2:
  case __S_S_RR_R2:
  case __LW_RR_R2 :
  case __SW_RR_R2 :
  case __DLW_RR   :
  case __L_D_RR   :
  case __DSW_RR   :
  case __DSZ_RR   :
  case __S_D_RR   :
  case __LH_RR    :

    /* Miscellaneous instructions */
  case __NOP:
  case __CTC1:
  case __CFC1: 
  case __SYSCALL:
  case __BREAK: sprintf(b," ");break;
  }
  strcat(buf, " ");
  strcat(buf, b);
}
